% New article: mdpi-Processes
% Special Issue: Industrial Process Operation State Sensing and Performance
% Optimization.
% Carry out M=200 times ControlLoop_PSO_RHC

STATE=cell(200,1);  %STATE is a cell array
t_fin=120;
UstarRHC=zeros(200,t_fin);
JMAT=zeros(200,1);
NS=t_fin+1; % N is the number of states
colx2=zeros(NS,1); %the column for the state variable x2
colx2(1)=0.; % always is 0

%Computation of K3 which is not a global variable
A = 0.0375;
K3=A*3600/1e6;

for ijk=1:200
    fprintf('&&&&&&&                     ijk = %2d \n', ijk);

    ControlLoop_PSO_RHC;  % evolution over a control horizon
    
    UstarRHC(ijk,:)=uRHC;%the vector containing the optimal control values is
                         %stored in the line ijk of the matrix UstarRHC
    
    % x2 is the integration of the light, that is uRHC
    for j=2:NS
     colx2(j)=colx2(j-1)+K3*uRHC(j-1);
    end    
    % state (H+1, 1) contains only the values for the state variable x1.
    state2=[state colx2]; %construction of the state variables' matrix
    STATE{ijk}=state2;    %the matrix state2 is stored in the cell array
    
    JMAT(ijk,1)=JRHC; %the value of the performance indexs is
                      %stored in the vector JMAT
    
    disp('#####################');
end 
%############ instruction protected to conserve WS_data200
%save('WS_data200','UstarRHC','STATE','JMAT');  
disp('******************************************************************');

